// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

assertEquals(0, V8ToLength(NaN));
assertEquals(0, V8ToLength(NaN));

assertEquals(0, V8ToLength(-Infinity));
assertEquals(0, V8ToLength(-Infinity));

assertEquals(0, V8ToLength(0));
assertEquals(0, V8ToLength(0));

assertEquals(0, V8ToLength(.5));
assertEquals(0, V8ToLength(.5));

assertEquals(42, V8ToLength(42.99999));
assertEquals(42, V8ToLength(42.99999));

assertEquals(9007199254740991, V8ToLength(9007199254740991));
assertEquals(9007199254740991, V8ToLength(9007199254740991));

assertEquals(9007199254740991, V8ToLength(Infinity));
assertEquals(9007199254740991, V8ToLength(Infinity));

assertEquals(0, V8ToLength(null));
assertEquals(0, V8ToLength(null));

assertEquals(1, V8ToLength(true));
assertEquals(1, V8ToLength(true));

assertEquals(0, V8ToLength(false));
assertEquals(0, V8ToLength(false));

assertEquals(0, V8ToLength(undefined));
assertEquals(0, V8ToLength(undefined));

assertEquals(0, V8ToLength("-1"));
assertEquals(0, V8ToLength("-1"));
assertEquals(123, V8ToLength("123"));
assertEquals(123, V8ToLength("123"));
assertEquals(0, V8ToLength("random text"));
assertEquals(0, V8ToLength("random text"));

assertThrows(function() { V8ToLength(Symbol.toPrimitive) }, TypeError);
assertThrows(function() { V8ToLength(Symbol.toPrimitive) }, TypeError);

var a = { toString: function() { return 54321 }};
assertEquals(54321, V8ToLength(a));
assertEquals(54321, V8ToLength(a));

var b = { valueOf: function() { return 42 }};
assertEquals(42, V8ToLength(b));
assertEquals(42, V8ToLength(b));

var c = {
  toString: function() { return "x"},
  valueOf: function() { return 123 }
};
assertEquals(123, V8ToLength(c));
assertEquals(123, V8ToLength(c));

var d = {
  [Symbol.toPrimitive]: function(hint) {
    assertEquals("number", hint);
    return 987654321;
  }
};
assertEquals(987654321, V8ToLength(d));
assertEquals(987654321, V8ToLength(d));

var e = new Date(0);
assertEquals(0, V8ToLength(e));
assertEquals(0, V8ToLength(e));
