// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

assertEquals(1, V8ToPrimitive(1));
assertEquals(1, V8ToPrimitive_Number(1));
assertEquals(1, V8ToPrimitive_String(1));
assertEquals(1, V8ToPrimitive(1));
assertEquals(1, V8ToPrimitive_Number(1));
assertEquals(1, V8ToPrimitive_String(1));

assertEquals(.5, V8ToPrimitive(.5));
assertEquals(.5, V8ToPrimitive_Number(.5));
assertEquals(.5, V8ToPrimitive_String(.5));
assertEquals(.5, V8ToPrimitive(.5));
assertEquals(.5, V8ToPrimitive_Number(.5));
assertEquals(.5, V8ToPrimitive_String(.5));

assertEquals(null, V8ToPrimitive(null));
assertEquals(null, V8ToPrimitive_Number(null));
assertEquals(null, V8ToPrimitive_String(null));
assertEquals(null, V8ToPrimitive(null));
assertEquals(null, V8ToPrimitive_Number(null));
assertEquals(null, V8ToPrimitive_String(null));

assertEquals(true, V8ToPrimitive(true));
assertEquals(true, V8ToPrimitive_Number(true));
assertEquals(true, V8ToPrimitive_String(true));
assertEquals(true, V8ToPrimitive(true));
assertEquals(true, V8ToPrimitive_Number(true));
assertEquals(true, V8ToPrimitive_String(true));

assertEquals(false, V8ToPrimitive(false));
assertEquals(false, V8ToPrimitive_Number(false));
assertEquals(false, V8ToPrimitive_String(false));
assertEquals(false, V8ToPrimitive(false));
assertEquals(false, V8ToPrimitive_Number(false));
assertEquals(false, V8ToPrimitive_String(false));

assertEquals(undefined, V8ToPrimitive(undefined));
assertEquals(undefined, V8ToPrimitive_Number(undefined));
assertEquals(undefined, V8ToPrimitive_String(undefined));
assertEquals(undefined, V8ToPrimitive(undefined));
assertEquals(undefined, V8ToPrimitive_Number(undefined));
assertEquals(undefined, V8ToPrimitive_String(undefined));

assertEquals("random text", V8ToPrimitive("random text"));
assertEquals("random text", V8ToPrimitive_Number("random text"));
assertEquals("random text", V8ToPrimitive_String("random text"));
assertEquals("random text", V8ToPrimitive("random text"));
assertEquals("random text", V8ToPrimitive_Number("random text"));
assertEquals("random text", V8ToPrimitive_String("random text"));

assertEquals(Symbol.toPrimitive, V8ToPrimitive(Symbol.toPrimitive));
assertEquals(Symbol.toPrimitive, V8ToPrimitive_Number(Symbol.toPrimitive));
assertEquals(Symbol.toPrimitive, V8ToPrimitive_String(Symbol.toPrimitive));
assertEquals(Symbol.toPrimitive, V8ToPrimitive(Symbol.toPrimitive));
assertEquals(Symbol.toPrimitive, V8ToPrimitive_Number(Symbol.toPrimitive));
assertEquals(Symbol.toPrimitive, V8ToPrimitive_String(Symbol.toPrimitive));

var a = { toString: function() { return "xyz" }};
assertEquals("xyz", V8ToPrimitive(a));
assertEquals("xyz", V8ToPrimitive_Number(a));
assertEquals("xyz", V8ToPrimitive_String(a));
assertEquals("xyz", V8ToPrimitive(a));
assertEquals("xyz", V8ToPrimitive_Number(a));
assertEquals("xyz", V8ToPrimitive_String(a));

var b = { valueOf: function() { return 42 }};
assertEquals(42, V8ToPrimitive(b));
assertEquals(42, V8ToPrimitive_Number(b));
assertEquals("[object Object]", V8ToPrimitive_String(b));
assertEquals(42, V8ToPrimitive(b));
assertEquals(42, V8ToPrimitive_Number(b));
assertEquals("[object Object]", V8ToPrimitive_String(b));

var c = {
  toString: function() { return "x"},
  valueOf: function() { return 123 }
};
assertEquals(123, V8ToPrimitive(c));
assertEquals(123, V8ToPrimitive_Number(c));
assertEquals("x", V8ToPrimitive_String(c));
assertEquals(123, V8ToPrimitive(c));
assertEquals(123, V8ToPrimitive_Number(c));
assertEquals("x", V8ToPrimitive_String(c));

var d = {
  [Symbol.toPrimitive]: function(hint) { return hint }
};
assertEquals("default", V8ToPrimitive(d));
assertEquals("number", V8ToPrimitive_Number(d));
assertEquals("string", V8ToPrimitive_String(d));
assertEquals("default", V8ToPrimitive(d));
assertEquals("number", V8ToPrimitive_Number(d));
assertEquals("string", V8ToPrimitive_String(d));

var e = new Date(0);
assertEquals(e.toString(), V8ToPrimitive(e));
assertEquals(0, V8ToPrimitive_Number(e));
assertEquals(e.toString(), V8ToPrimitive_String(e));
assertEquals(e.toString(), V8ToPrimitive(e));
assertEquals(0, V8ToPrimitive_Number(e));
assertEquals(e.toString(), V8ToPrimitive_String(e));
