// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

assertEquals("1", V8ToString(1));
assertEquals("1", V8ToString(1));

assertEquals("0.5", V8ToString(.5));
assertEquals("0.5", V8ToString(.5));

assertEquals("null", V8ToString(null));
assertEquals("null", V8ToString(null));

assertEquals("true", V8ToString(true));
assertEquals("true", V8ToString(true));

assertEquals("false", V8ToString(false));
assertEquals("false", V8ToString(false));

assertEquals("undefined", V8ToString(undefined));
assertEquals("undefined", V8ToString(undefined));

assertEquals("random text", V8ToString("random text"));
assertEquals("random text", V8ToString("random text"));

assertThrows(function() { V8ToString(Symbol.toPrimitive) }, TypeError);
assertThrows(function() { V8ToString(Symbol.toPrimitive) }, TypeError);

var a = { toString: function() { return "xyz" }};
assertEquals("xyz", V8ToString(a));
assertEquals("xyz", V8ToString(a));

var b = { valueOf: function() { return 42 }};
assertEquals("[object Object]", V8ToString(b));
assertEquals("[object Object]", V8ToString(b));

var c = {
  toString: function() { return "x"},
  valueOf: function() { return 123 }
};
assertEquals("x", V8ToString(c));
assertEquals("x", V8ToString(c));

var d = {
  [Symbol.toPrimitive]: function(hint) { return hint }
};
assertEquals("string", V8ToString(d));
assertEquals("string", V8ToString(d));

var e = new Date(0);
assertEquals(e.toString(), V8ToName(e));
assertEquals(e.toString(), V8ToName(e));
